#pragma once

#include "modifier.h"

namespace cppmp
{

    namespace __impl
    {
        /* decay_impl */

        template <typename T, typename U = remove_reference_t<T>>
        struct decay_impl
            { using type = remove_cv_t<U>; };

        template <typename T, typename U>
        struct decay_impl<T, U[]>
            { using type = U*; };

        template <typename T, typename U, std::size_t N>
        struct decay_impl<T, U[N]>
            { using type = U*; };

        template <typename T, typename R, typename ...A>
        struct decay_impl<T, R(A...)>
            { using type = R(*)(A...); };

        template <typename T, typename R, typename ...A>
        struct decay_impl<T, R(A..., ...)>
            { using type = R(*)(A..., ...); };

    }

    template<class T>
    struct decay
        : public __impl::decay_impl<T>
        { };

}
